/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
import '@material/mwc-ripple/mwc-ripple';
import { Ripple } from '@material/mwc-ripple/mwc-ripple';
import { RippleHandlers } from '@material/mwc-ripple/ripple-handlers';
import { LitElement, TemplateResult } from 'lit-element';
/**
 * Fab Base class logic and template definition
 * @soyCompatible
 */
export declare class FabBase extends LitElement {
    static shadowRootOptions: ShadowRootInit;
    ripple: Promise<Ripple | null>;
    mini: boolean;
    exited: boolean;
    disabled: boolean;
    extended: boolean;
    showIconAtEnd: boolean;
    reducedTouchTarget: boolean;
    icon: string;
    label: string;
    protected shouldRenderRipple: boolean;
    protected useStateLayerCustomProperties: boolean;
    protected rippleHandlers: RippleHandlers;
    /**
     * @soyTemplate
     * @soyClasses fabClasses: .mdc-fab
     */
    protected render(): TemplateResult;
    /** @soyTemplate */
    protected renderIcon(): TemplateResult;
    /** @soyTemplate */
    protected renderTouchTarget(): TemplateResult;
    /** @soyTemplate */
    protected renderLabel(): TemplateResult;
    /** @soyTemplate */
    protected renderBeforeRipple(): TemplateResult;
    /** @soyTemplate */
    protected renderRipple(): TemplateResult | string;
    protected handleRippleActivate(event?: Event): void;
    protected handleRippleStartPress(event?: Event): void;
    protected handleRippleDeactivate(): void;
    protected handleRippleMouseEnter(): void;
    protected handleRippleMouseLeave(): void;
    protected handleRippleFocus(): void;
    protected handleRippleBlur(): void;
}
